/**
 ** sparkSituationAssessmentCodels.cc
 **
 ** Codels called by execution task sparkMainTask
 **
 ** Author: E. Akin Sisbot
 ** Date: Aug 10
 **
 **/

#include <portLib.h>

#include "server/sparkHeader.h"
#include "sparkm3d.h"
#include "libmove3d/planners/GTP/taskmanager.hpp"

#include "libeuler/pomEuler.h"

#ifdef ORO
#include "sparkOro.h"
#endif

#if defined(USE_MIGHTABILITY_MAPS)
extern agents_activity_facts Ag_Activity_Fact[MAXI_NUM_OF_AGENT_FOR_HRI_TASK];
extern int STOP_AGENT_STATE_ANALYSIS;
extern int PRINT_AGENT_STATE_FACTS;
extern Agent_Activity_fact_by_names Hum_facts_by_name[MAXI_NUM_OF_AGENT_FOR_HRI_TASK];
extern int NewDataForASA;
extern int SHOW_OBJECT_FACTS;
extern int SHOW_OBJ_FACTS_BY_ARROW;
extern int OBJ_IS_VISIBLE_FOR_AGENT[MAXI_NUM_OF_ALLOWED_OBJECTS_IN_ENV][MAXI_NUM_OF_AGENT_FOR_HRI_TASK];
extern int OBJ_IS_REACHABLE_FOR_AGENT[MAXI_NUM_OF_ALLOWED_OBJECTS_IN_ENV][MAXI_NUM_OF_AGENT_FOR_HRI_TASK][MAXI_NUM_OF_HANDS_OF_AGENT];

#endif

/* sparkUpdateOneSituationAssessmentMain  -  codel EXEC of UpdateOneSituationAssessment

   this function uses the same processing used in compute_geometric_facts of libhri. Onto update should be managed better.
*/
ACTIVITY_EVENT
sparkUpdateControlOneSituationAssessmentMain(SPARK_SPECIFIC_SA_PARAM *specificSAParam, int *report)
{
  int a_i,e_i,agentPartIndex;
  HRI_AGENT * agent = NULL;
  HRI_ENTITY * entity1 = NULL;
  HRI_ENTITY * entity2 = NULL;

  HRI_KNOWLEDGE_ON_ENTITY * kn_on_ent;
  //HRI_VISIBILITY * vis_result;
  ENUM_HRI_VISIBILITY_PLACEMENT res;
  double elevation, azimuth;
  HRI_REACHABILITY reachability_result;

  HRI_VISIBILITY * vis_result;

  if(gEnv == NULL || gAgents==NULL) {
    *report = S_spark_NOT_INITIALIZED;
    return ETHER;
  }

  for(a_i=0; a_i<gAgents->all_agents_no; a_i++) {
    if(strcasestr(gAgents->all_agents[a_i]->robotPt->name, specificSAParam->agent.name)) {
      agent = gAgents->all_agents[a_i];
      break;
    }
  }
  if(agent == NULL) {
    *report = S_spark_AGENT_NOT_FOUND;
    return ETHER;
  }

  for(e_i=0; e_i<gEntities->entities_nb; e_i++) {
    if (!strcmp(specificSAParam->entity1.name, gEntities->entities[e_i]->name)) {
      entity1 = gEntities->entities[e_i];
      kn_on_ent = &agent->knowledge->entities[e_i];
      break;
    }
  }
  if(entity1 == NULL) {
    *report = S_spark_OBJECT_NOT_FOUND;
    return ETHER;
  }


  /// Search for second entity only for processing type that needs it
  if(specificSAParam->updateControlType == SPARK_PLACEMENT_REL_PROC){
    for(e_i=0; e_i<gEntities->entities_nb; e_i++) {
      if (!strcmp(specificSAParam->entity2.name, gEntities->entities[e_i]->name)) {
        entity2 = gEntities->entities[e_i];
        break;
      }
    }
    if(entity2 == NULL) {
      *report = S_spark_SECOND_OBJECT_NOT_FOUND;
      return ETHER;
    }
  }

  if(specificSAParam->updateControlType == SPARK_REACH_PROC ){
    // TODO: Fix this global variable use. It's ugly.
    GIK_VIS = 500;
    reachability_result = hri_is_reachable(entity1, agent);
    if ( kn_on_ent->reachability ==  reachability_result) {
      if ( kn_on_ent->reachability_ischanged)
        kn_on_ent->reachability_ischanged = FALSE;
    }
    else {
      kn_on_ent->reachability = reachability_result;
      kn_on_ent->reachability_ischanged = TRUE;
      kn_on_ent->reachability_isexported = FALSE;
    }
  }
  else if(specificSAParam->updateControlType == SPARK_LOOKAT_PROC){
    // LOOKS AT / VISIBILITY PLACEMENT - FOV,FOA,OOF
    // TODO: visibility placement for robot parts
    if(entity1->disappeared)
      res = HRI_UK_VIS_PLACE;
    else
      hri_entity_visibility_placement(agent, entity1, true, kn_on_ent->is_placed_from_visibility, &res, &elevation, &azimuth);

    // need to update is_exported , is_changed?
    kn_on_ent->is_placed_from_visibility = (HRI_VISIBILITY_PLACEMENT) res;
    vis_result = MY_ALLOC(HRI_VISIBILITY,1);
    g3d_compute_visibility_for_given_entities(&entity1, agent, vis_result, 1);
    if ( kn_on_ent->visibility  ==  vis_result[0]) {
      if ( kn_on_ent->visibility_ischanged)
        kn_on_ent->visibility_ischanged  = FALSE;
    }
    else {
      kn_on_ent->visibility = vis_result[0];
      kn_on_ent->visibility_ischanged = TRUE;
      kn_on_ent->visibility_isexported = FALSE;
    }
    MY_FREE(vis_result,HRI_VISIBILITY,1);

    if ( (((HRI_VISIBILITY_PLACEMENT) res) == HRI_FOA) && (kn_on_ent->visibility  == HRI_VISIBLE)) {
      if (kn_on_ent->is_looked_at != HRI_TRUE_V){
        kn_on_ent->is_looked_at = HRI_TRUE_V;
        kn_on_ent->is_looked_at_ischanged = TRUE;
        kn_on_ent->is_looked_at_isexported = FALSE;
      }
    }
    else {
      if (kn_on_ent->is_looked_at == HRI_TRUE_V){
        kn_on_ent->is_looked_at_ischanged = TRUE;
        kn_on_ent->is_looked_at_isexported = FALSE;
      }
      if( (res == HRI_UK_VIS_PLACE) || (kn_on_ent->visibility  == HRI_UK_VIS))
        kn_on_ent->is_looked_at = HRI_UK_V;
      else
        kn_on_ent->is_looked_at = HRI_FALSE_V;
    }

  }
  else if(specificSAParam->updateControlType ==  SPARK_DELETE_DIVERGENT_POSITION){
    hri_delete_agent_entity_divergent_position(agent,e_i);
  }
  else if(specificSAParam->updateControlType ==  SPARK_FORCE_AGENT_KNOWS_POSITION){
    if(!kn_on_ent->hasEntityPositionKnowledge){
      kn_on_ent->hasEntityPositionKnowledge = true;
      agent->knowledge->numUnknownPositions--;
    }
  }
  else if(specificSAParam->updateControlType ==  SPARK_FORCE_AGENT_DOESNT_KNOW_POSITION){
    if(kn_on_ent->hasEntityPositionKnowledge){
      kn_on_ent->hasEntityPositionKnowledge = false;
      agent->knowledge->numUnknownPositions++;
      if(kn_on_ent->hasEntityPosition){
        kn_on_ent->hasEntityPosition = false;
        MY_FREE(kn_on_ent->entityPositionForAgent, double, kn_on_ent->entPt->robotPt->nb_dof);
        agent->knowledge->numDivergentPositions--;
      }
    }
  }
  else if((specificSAParam->updateControlType ==  SPARK_START_MANAGE_DISTANCE_INFO) || (specificSAParam->updateControlType ==  SPARK_STOP_MANAGE_DISTANCE_INFO)){
    agentPartIndex = specificSAParam->agentPartIndex;
    if((agentPartIndex < -1) || (agentPartIndex >= agent->hand_nb)){
      *report = S_spark_AGENT_PART_NOT_FOUND;
      return ETHER;
    }
    else{
      if(specificSAParam->updateControlType ==  SPARK_START_MANAGE_DISTANCE_INFO)
        hri_add_agent_entity_distance_management(agent,agentPartIndex,e_i);
      else
        hri_delete_agent_entity_distance_management(agent,agentPartIndex,e_i);
    }
  }
  else{
    *report = S_spark_UNMANAGED_TYPE;
    return ETHER;
  }


  *report = OK;
  return ETHER;
}

/* sparkUpdateAllSAMain  -  codel EXEC of UpdateAllSituationAssessment
   this function will force or inhibit the update of situation assessement
*/
// request used to force reprocessing, to print value or update some parameters values, ...
ACTIVITY_EVENT
sparkUpdateAllSAMain( SPARK_SA_UPDATE_PARAM *updateAllSAParam, int *report)
{
  if(gEntities == NULL) {
    *report = S_spark_NOT_INITIALIZED;
    return ETHER;
  }
  if( updateAllSAParam->type == SPARK_UPDATE_ALL){
    gEntities->needSituationAssessmentUpdate = TRUE;
  }
  else if( updateAllSAParam->type == SPARK_UPDATE_LOOK_AT){
    gEntities->needLooksatUpdate = TRUE;
  }
  else if( updateAllSAParam->type == SPARK_BLOCK_UPDATE_ALL){
    gEntities->isWorldStatic = FALSE;
    gEntities->forbidWorldStatic = TRUE;
  }
  else if( updateAllSAParam->type == SPARK_DEBLOCK_UPDATE_ALL){
    gEntities->forbidWorldStatic = FALSE;
  }
  else if( updateAllSAParam->type == SPARK_PRINT_ALL_UPDATE){
    SDI_F->state.oroPrintEnabled = TRUE;
  }
  else if( updateAllSAParam->type == SPARK_NOPRINT_ALL_UPDATE){
    SDI_F->state.oroPrintEnabled = FALSE;
  }
  else if( updateAllSAParam->type == SPARK_PRINT_ALL_SPARK_ORO){
#ifdef ORO
    printAllOroFacts(gAgents, gEntities);
#if defined(USE_MIGHTABILITY_MAPS)
    printAgentsActivityFactsForORO(gAgents,HUMAN1_MA);
#endif
#endif
  }
  else if( updateAllSAParam->type == SPARK_REEXPORT_ALL_SPARK_ORO){
#ifdef ORO
    clearFacts();
    reinitFactsForOROExportControl(gAgents, gEntities);
    prepareFactsForORO(gAgents, gEntities);
#if defined(USE_MIGHTABILITY_MAPS)
    reinitAgentsActivityFactsForOROExportControl(gAgents,HUMAN1_MA);
    prepareAgentsActivityFactsForORO(gAgents,Ag_Activity_Fact,HUMAN1_MA);
#endif
    sendToORO(SDI_F->oroServerAddress.address, SDI_F->oroServerAddress.port);
#endif
  }
  else if( updateAllSAParam->type == SPARK_CREATE_VISIBILITY_IMAGES_ON){
    gEntities->printVisibilityImages = TRUE;
  }
  else if( updateAllSAParam->type == SPARK_CREATE_VISIBILITY_IMAGES_OFF){
    gEntities->printVisibilityImages = FALSE;
  }
  else if( updateAllSAParam->type == SPARK_ALLOW_DISAPPEAR){
    gEntities->general_allow_disappear = TRUE;
  }
  else if( updateAllSAParam->type == SPARK_FOREBID_DISAPPEAR){
    gEntities->general_allow_disappear = FALSE;
  }
  else if( updateAllSAParam->type == SPARK_PRINT_VIMAN_INPUT){
    SDI_F->state.vimanPrintEnabled = TRUE;
  }
  else if( updateAllSAParam->type == SPARK_NOPRINT_VIMAN_INPUT){
    SDI_F->state.vimanPrintEnabled = FALSE;
  }
  else if( updateAllSAParam->type == SPARK_UPDATE_REACHABILITY_DISTANCE){
    gEntities->needToUpdateParameters = TRUE;
    gEntities->numParameterToUpdate = 0;
    gEntities->hackedReachabilityDistance = updateAllSAParam->doubleUpdatedValue;
  }
  else if( updateAllSAParam->type == SPARK_UPDATE_NOT_STATIC_WITHOUT_RECOMPUTATION_ITER_MAX){
    gEntities->maxWorldNotStaticBeforeRecompute = updateAllSAParam->intUpdatedValue;
  }
  else if( updateAllSAParam->type == SPARK_UPDATE_NO_EVENT_STEPS_BEFORE_STATIC_ITER_MIN){
    gEntities->lastEventsInTheWorldStepsMin = updateAllSAParam->intUpdatedValue;
  }
  else if( updateAllSAParam->type == SPARK_UPDATE_DISAPEAR_ITER_MAX){
    gEntities->needToUpdateParameters = TRUE;
    gEntities->numParameterToUpdate = 1;
    gEntities->maxUnexplainedUndetectionIter = updateAllSAParam->intUpdatedValue;
  }
  else if( updateAllSAParam->type == SPARK_UPDATE_IS_ON_MAX_DIST){
    gEntities->needToUpdateParameters = TRUE;
    gEntities->numParameterToUpdate = 2;
    gEntities->isOnThreshold = updateAllSAParam->doubleUpdatedValue;
  }
  else if( updateAllSAParam->type == SPARK_UPDATE_AVERAGE_MOTION_EXPORT_THRESHOLD){
    gEntities->averageDistanceScoreExportThreshold = updateAllSAParam->doubleUpdatedValue;
  }

  else if( updateAllSAParam->type == SPARK_SWITCH_PRINT_SA_RECOMPUTE_STATUS){
    if(gEntities->printSARecomputeStatus) {
      gEntities->printSARecomputeStatus=FALSE;
      printf("stop printing SA status\n");
    }
    else{
      gEntities->printSARecomputeStatus=TRUE;
      printf("start printing SA status\n");
    }
  }
  else if( updateAllSAParam->type == SPARK_SWITCH_DISPLAY_SA_RECOMPUTE_STATUS){
    if(gEntities->displaySARecomputeStatus) {
      gEntities->displaySARecomputeStatus=false;
      printf("stop displaying SA status\n");
    }
    else{
      gEntities->displaySARecomputeStatus=true;
      printf("start displaying SA status\n");
    }
  }
  else if( updateAllSAParam->type == SPARK_SWITCH_DRAW_ACTION_MONITORING_SPHERES){
    if(gSpheres->drawSpheres){
      printf("stop drawing monitoring spheres\n");
      gSpheres->drawSpheres = FALSE;
    }
    else{
      printf("start drawing monitoring spheres\n");
      gSpheres->drawSpheres = TRUE;
      gSpheres->drawSpheresOpacity = updateAllSAParam->doubleUpdatedValue;
    }
  }
  else if( updateAllSAParam->type == SPARK_ENABLE_DIVERGENT_POSITION){
    gEntities->manageDivergentBeliefs = true;
  }
  else if( updateAllSAParam->type == SPARK_DISABLE_DIVERGENT_POSITION){
    gEntities->manageDivergentBeliefs = false;
  }
  else if( updateAllSAParam->type == SPARK_START_SEND_LOOK_DIRECTION_ORO_FACTS){
    SDI_F->state.inhibitLookDirectionOroFactsSending = FALSE;
  }
  else if( updateAllSAParam->type == SPARK_STOP_SEND_LOOK_DIRECTION_ORO_FACTS){
    SDI_F->state.inhibitLookDirectionOroFactsSending = TRUE;
  }
  else if( updateAllSAParam->type == SPARK_PRINT_LOOPING_REQUEST_TIME){
    if(SDI_F->requestTimeInfo.printLoopRequestExecutionTimeEnabled){
      printf("stop printing loop request time\n");
      SDI_F->requestTimeInfo.printLoopRequestExecutionTimeEnabled = FALSE;
    }
    else{
      printf("start printing loop request time\n");
      SDI_F->requestTimeInfo.printLoopRequestExecutionTimeEnabled = TRUE;
    }
  }
  else if( updateAllSAParam->type == SPARK_PRINT_LOOPING_REQUEST_TIME_ITER){
    SDI_F->requestTimeInfo.printLoopRequestExecutionTimePrintPeriod = updateAllSAParam->intUpdatedValue;
    printf("printing loop request time iter is %d\n",SDI_F->requestTimeInfo.printLoopRequestExecutionTimePrintPeriod);
  }
  else if( updateAllSAParam->type == SPARK_FORCE_REACHABILITY_REEXPORT_TO_ORO){
    SDI_F->state.reexportReachabilityFactsToOro = TRUE;
  }
  else {
    *report = S_spark_UNKNOWN_UPDATE_TYPE;
    return ETHER;
  }


  *report = OK;
  return ETHER;
}

void setAgActivtitySituationAssessmentUpdateNeeds(int for_agent)
{

#if defined(USE_MIGHTABILITY_MAPS)
  printf(" ========= Status for agent %s =======\n",gEnv->robot[Ag_Activity_Fact[HUMAN1_MA].agent_index]->name);

  printf(" Whole Body : %d \n",Ag_Activity_Fact[for_agent].whole_body);
  printf(" Torso: %d \n",Ag_Activity_Fact[for_agent].torso);
  printf(" Head: %d \n",Ag_Activity_Fact[for_agent].head);

  printf(" Right Hand: %d \n",Ag_Activity_Fact[for_agent].right_hand);
  printf(" Right Hand: %d \n",Ag_Activity_Fact[for_agent].right_hand_mode);
  printf(" Left Hnad: %d \n",Ag_Activity_Fact[for_agent].left_hand);
  printf(" Left Hnad: %d \n",Ag_Activity_Fact[for_agent].left_hand_mode);
#endif
}

int decideSituationAssessmentAgentRelatedUpdate(int agentIndex){
  int eventsInTheWorld = FALSE;
  int needSituationAssessmentUpdate = FALSE;
  int needLooksatUpdate = FALSE;

  ///Whole Body and Torso and hand move (in manipulation mode) require to recompute ALL

  ///Head Move require to recompute only look at

  ///All other move than head imply eventsInTheWorld FALSE.

#if defined(USE_MIGHTABILITY_MAPS)
  if((Ag_Activity_Fact[agentIndex].whole_body == AGENT_HAS_MOVED) || (Ag_Activity_Fact[agentIndex].whole_body == AGENT_MOVING) ){
    eventsInTheWorld = TRUE;
    needSituationAssessmentUpdate = TRUE;
    //printf("Agent %d moving %d \n",agentIndex,Ag_Activity_Fact[agentIndex].whole_body);
  }

  if((Ag_Activity_Fact[agentIndex].torso == AGENT_TORSO_HAS_TURNED) || (Ag_Activity_Fact[agentIndex].torso == AGENT_TORSO_TURNING) ){
    eventsInTheWorld = TRUE;
    needSituationAssessmentUpdate = TRUE;
  }

  if(((Ag_Activity_Fact[agentIndex].right_hand == AGENT_HAND_HAS_MOVED) || (Ag_Activity_Fact[agentIndex].right_hand == AGENT_HAND_MOVING)) && (Ag_Activity_Fact[agentIndex].right_hand_mode == AGENT_HAND_AT_MANIPULATION_MODE) ){
    eventsInTheWorld = TRUE;
    needSituationAssessmentUpdate = TRUE;
  }

  if(((Ag_Activity_Fact[agentIndex].left_hand == AGENT_HAND_HAS_MOVED) || (Ag_Activity_Fact[agentIndex].left_hand == AGENT_HAND_MOVING)) && (Ag_Activity_Fact[agentIndex].left_hand_mode == AGENT_HAND_AT_MANIPULATION_MODE) ){
    eventsInTheWorld = TRUE;
    needSituationAssessmentUpdate = TRUE;
  }

  if((Ag_Activity_Fact[agentIndex].head == AGENT_HEAD_HAS_TURNED) || (Ag_Activity_Fact[agentIndex].head == AGENT_HEAD_TURNING) ){
    needLooksatUpdate = TRUE;
  }
#endif
  if(eventsInTheWorld)
    gEntities->eventsInTheWorld = TRUE;
  if(needSituationAssessmentUpdate)
    gEntities->needSituationAssessmentUpdate = TRUE;
  if(needLooksatUpdate)
    gEntities->needLooksatUpdate = TRUE;

  return TRUE;
}


int feedVisReachVisualisationStruct(int agentIndex){

#if defined(USE_MIGHTABILITY_MAPS)
  int a_i, agent_index;
  if(gAgents == NULL || gEnv == NULL || gEntities == NULL) {
    return FALSE;
  }

  if (SHOW_OBJECT_FACTS == 1){
    for(a_i=0; a_i<gAgents->all_agents_no; a_i++) {
      agent_index = Ag_Activity_Fact[agentIndex].agent_index;
      if( agent_index >= 0){
        if( strcasestr(gAgents->all_agents[a_i]->robotPt->name,gEnv->robot[agent_index]->name)){
          for(int e_i=0; e_i<gEntities->entities_nb; e_i++) {
            if((gEntities->entities[e_i]->subtype == HRI_MOVABLE_OBJECT) && gEntities->entities[e_i]->is_present){

              if (gAgents->all_agents[a_i]->knowledge->entities[e_i].visibility == HRI_VISIBLE)
                OBJ_IS_VISIBLE_FOR_AGENT[gEntities->entities[e_i]->indexInEnv][agentIndex]= 1;
              else
                OBJ_IS_VISIBLE_FOR_AGENT[gEntities->entities[e_i]->indexInEnv][agentIndex]= 0;

              if (gAgents->all_agents[a_i]->knowledge->entities[e_i].reachability == HRI_REACHABLE)
                OBJ_IS_REACHABLE_FOR_AGENT[gEntities->entities[e_i]->indexInEnv][agentIndex][0]= 1;
              else
                OBJ_IS_REACHABLE_FOR_AGENT[gEntities->entities[e_i]->indexInEnv][agentIndex][0]= 0;
            }
          }
          break;
        }
      }
    }
  }

#endif

  return TRUE;
}


/* sparkComputeFactsStart  -  codel START of ComputeFacts
   Returns:  START EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
sparkComputeFactsStart(int *report)
{
  return EXEC;
}


/* sparkComputeFactsMain  -  codel EXEC of ComputeFacts
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
sparkComputeFactsMain(int *report)
{
  if (gAgents == NULL) return EXEC;

  //float clock_val = 0;
  //float elapsed_time = 0;

  /// time assessment
  double timeStart;
  getRequestTimeStart(SDI_F->requestTimeInfo.printLoopRequestExecutionTimeEnabled,timeStart);

  //clock_val = clock();
#if defined(USE_MIGHTABILITY_MAPS)
  // Tells if human moved
  decideSituationAssessmentAgentRelatedUpdate(HUMAN1_MA);
  //ASA do not work for robot
  // #if defined(JIDO)
  //   decideSituationAssessmentAgentRelatedUpdate(JIDO_MA);
  // #endif
  // #if defined(PR2)
  //   decideSituationAssessmentAgentRelatedUpdate(PR2_MA);
  // #endif
#endif

  hri_manage_object_disappearance_and_move(gAgents, gEntities,gAgents->source_agent_idx );
  hri_compute_geometric_facts(gAgents, gEntities,gAgents->source_agent_idx);
#if defined(USE_MIGHTABILITY_MAPS)
  feedVisReachVisualisationStruct(HUMAN1_MA);
  //feedVisReachVisualisationStruct(JIDO_MA);
#endif
#ifdef ORO
  clearFacts();
  prepareFactsForORO(gAgents, gEntities);
#if defined(USE_MIGHTABILITY_MAPS)
  prepareAgentsActivityFactsForORO(gAgents,Ag_Activity_Fact,HUMAN1_MA);
#endif
  sendToORO(SDI_F->oroServerAddress.address, SDI_F->oroServerAddress.port);
#endif

  //elapsed_time = (clock() - clock_val)/CLOCKS_PER_SEC;
  //printf("TIME passed for: %f overall,\n", elapsed_time);
  //Get End Time if needed
  trackRequestTime(SDI_F->requestTimeInfo.printLoopRequestExecutionTimeEnabled,timeStart,SDI_F->requestTimeInfo.printLoopRequestExecutionTimeComputeFactsIndex);

  return EXEC;
}


/* sparkComputeFactsEnd  -  codel END of ComputeFacts
   Returns:  END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
sparkComputeFactsEnd(int *report)
{
  return ETHER;
}


/* sparkComputeFactsInter  -  codel INTER of ComputeFacts
   Returns:  INTER ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
sparkComputeFactsInter(int *report)
{
  return ETHER;
}


TaskManager *TM;


/*------------------------------------------------------------------------
 * GetUpdatedGTPFacts
 *
 * Description: 
 *
 * Reports:      OK
 *              S_spark_FAIL_TO_GET_GTP_FACTS, S_spark_FAIL_FACTS_OVERFLOW_GTP
 */

/* sparkGetUpdatedGTPFacts  -  
   Returns:  START EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
sparkGetUpdatedGTPFacts(int *WSFId, SPARK_LIST_GTP_FACTS* list_gtp_facts, int *report)
{
  printf("Start fact update GTP\n");
  int id = global_Project->getActiveScene()->getFactsManager()->computeFacts(false);
  if (id == -1)
  {
    *report= S_spark_FAIL_TO_GET_GTP_FACTS;
    return ETHER;
  }
  printf("id: %d\n", id);
  WorldStateFacts* WSF = global_Project->getActiveScene()->getFactsManager()->getWSFromId(id);
  if (!WSF)
  {
    *report= S_spark_FAIL_TO_GET_GTP_FACTS;
    return ETHER;
  }
  vector<Fact> vf;
  if(*WSFId <0)
    vf = WSF->getMeaningfulFacts();
  else
    vf = WSF->getUpdatedFacts(global_Project->getActiveScene()->getFactsManager()->getWSFromId(*WSFId));
  printf("[GTP] vf.size: %d\n", vf.size());

  //if (vf.size() > NB_MAX_FACTS)
  //{
  //  list_gtp_facts->nbFacts = vf.size();
  //  *report = S_mhp_FAIL_FACTS_OVERFLOW_GTP;
  //  return ETHER;
  //}
 

 
  list_gtp_facts->nbFacts = vf.size();
  list_gtp_facts->wsId = id;
  if (vf.size() > SPARK_NB_MAX_FACTS)
  {
    *report = S_spark_FAIL_FACTS_OVERFLOW_GTP;
    return ETHER;
  }
  for(unsigned int i = 0; i < list_gtp_facts->nbFacts; i++)
  {
     strcpy(list_gtp_facts->gtp_fact[i].factType.name, vf.at(i).getType().factType.c_str()); 
     strcpy(list_gtp_facts->gtp_fact[i].factSubType.name, vf.at(i).getType().factSubType.c_str()); 
     strcpy(list_gtp_facts->gtp_fact[i].mainEntity.name, vf.at(i).getMainEntity()->getName().c_str()); 
     strcpy(list_gtp_facts->gtp_fact[i].targetEntity.name, vf.at(i).getTargetEntity()->getName().c_str()); 

     if (vf.at(i).isItComputed())
        list_gtp_facts->gtp_fact[i].isComputed = GEN_TRUE;
     else
        list_gtp_facts->gtp_fact[i].isComputed = GEN_FALSE;

     if (vf.at(i).getBoolValue())
        list_gtp_facts->gtp_fact[i].boolValue = GEN_TRUE;
     else
        list_gtp_facts->gtp_fact[i].boolValue = GEN_FALSE; 
     
     list_gtp_facts->gtp_fact[i].valueType = vf.at(i).getValueType();
     list_gtp_facts->gtp_fact[i].specificValue = vf.at(i).getSpecValue();
  }
  
  return ETHER;
}


/*------------------------------------------------------------------------
 * InitGTP
 *
 * Description: 
 *
 */

/* sparkInitGtp
   Returns:  START EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
sparkInitGtp(int *report)
{
  TM = new TaskManager();
  TM->init();
  return ETHER;
}



/* ------------------------------------------------------------- */
/* ---------  Manage Spheres Monitor Poster  ------------------- */
/* ------------------------------------------------------------- */

void publishSpheresMonitorPoster( void )
{
  sparkMonitoringSpheresmonitoringSpheresPosterWrite(SPARK_MONITORINGSPHERES_POSTER_ID, &SDI_F->monitoringSpheres);
}

static int updateSpheresMonitorPoster( void )
{
  int i;
  int iterModif = 0;
  if(gSpheres->modifIndex != SDI_F->monitoringSpheres.modifIndex){
    SDI_F->monitoringSpheres.modifIndex = gSpheres->modifIndex;
    //Reinit all spheres modifIndex if > 100
    if(gSpheres->modifIndex > 100)
      gSpheres->modifIndex = 0;

    for(i=0; i<SPARK_NUM_SPHERES_MAX; i++) {
      if(gSpheres->spheres[i]->modifIndex != SDI_F->monitoringSpheres.spheres[i].modifIndex){
        //Reinit sphere modifIndex if > 100
        if(gSpheres->spheres[i]->modifIndex > 100)
          gSpheres->spheres[i]->modifIndex = 0;
        iterModif++;
        SDI_F->monitoringSpheres.spheres[i].modifIndex = gSpheres->spheres[i]->modifIndex;

        SDI_F->monitoringSpheres.spheres[i].isSphereActive = gSpheres->spheres[i]->isSphereActive;
        strcpy(SDI_F->monitoringSpheres.spheres[i].agentName.name, gSpheres->spheres[i]->agentName);
        SDI_F->monitoringSpheres.spheres[i].agentIndex = gSpheres->spheres[i]->agentIndex;
        strcpy(SDI_F->monitoringSpheres.spheres[i].objectName.name, gSpheres->spheres[i]->objectName);

        SDI_F->monitoringSpheres.spheres[i].entityIndex = gSpheres->spheres[i]->entityIndex;
        SDI_F->monitoringSpheres.spheres[i].handIndexInput = gSpheres->spheres[i]->handIndexInput;
        SDI_F->monitoringSpheres.spheres[i].sphereCenter.x = gSpheres->spheres[i]->sphereCenterX;
        SDI_F->monitoringSpheres.spheres[i].sphereCenter.y = gSpheres->spheres[i]->sphereCenterY;
        SDI_F->monitoringSpheres.spheres[i].sphereCenter.z = gSpheres->spheres[i]->sphereCenterZ;
        SDI_F->monitoringSpheres.spheres[i].sphereRadius = gSpheres->spheres[i]->sphereRadius;
        SDI_F->monitoringSpheres.spheres[i].sphereType = (SPARK_SPHERE_TYPE) gSpheres->spheres[i]->sphereType;
        SDI_F->monitoringSpheres.spheres[i].monitorEnterInResult = gSpheres->spheres[i]->monitorEnterInResult;
        SDI_F->monitoringSpheres.spheres[i].monitorGetOutResult = gSpheres->spheres[i]->monitorGetOutResult;
        SDI_F->monitoringSpheres.spheres[i].handIndexResult = gSpheres->spheres[i]->handIndexResult;
        SDI_F->monitoringSpheres.spheres[i].filteringTimeThreshold = gSpheres->spheres[i]->filteringTimeThreshold;
      }
    }
  }
  if(iterModif > 0)
    publishSpheresMonitorPoster();

  return TRUE;
}

/* ------------------------------------------------------------- */
/* ----------------------- Test Sphere Monitors ---------------- */
/* ------------------------------------------------------------- */

ACTIVITY_EVENT
sparkTestSphereMonitorStart(int *report)
{
  if(!initSpheresIsDone){
    gSpheres = hri_create_spheres(SPARK_NUM_SPHERES_MAX);
    initSpheresIsDone = true;
  }
  return EXEC;
}

ACTIVITY_EVENT
sparkTestSphereMonitorMain(int *report)
{
  /// time assessment
  double timeStart;
  getRequestTimeStart(SDI_F->requestTimeInfo.printLoopRequestExecutionTimeEnabled,timeStart);

  hriTestMonitor(gAgents, gEntities,gSpheres,SPARK_NUM_SPHERES_MAX,0);
  updateSpheresMonitorPoster();

  trackRequestTime(SDI_F->requestTimeInfo.printLoopRequestExecutionTimeEnabled,timeStart,SDI_F->requestTimeInfo.printLoopRequestExecutionTimeTestSpheresIndex);

  return EXEC;
}

/* ------------------------------------------------------------- */
/* ----------------------- Update Sphere Monitors -------------- */
/* ------------------------------------------------------------- */

ACTIVITY_EVENT
sparkUpdateSphereMonitorStart(SPARK_ACTION_MONITORING_SPHERE_INPUT_PARAMS *monitoringSphereInput,int *report)
{
  if(!initSpheresIsDone){
    gSpheres = hri_create_spheres(SPARK_NUM_SPHERES_MAX);
    initSpheresIsDone = true;
  }
  return EXEC;
}

ACTIVITY_EVENT
sparkUpdateSphereMonitorMain(SPARK_ACTION_MONITORING_SPHERE_INPUT_PARAMS *monitoringSphereInput, int *report)
{
  int e_j,a_i;

  if(monitoringSphereInput->monitorIndex >= SPARK_NUM_SPHERES_MAX){
    *report = S_spark_SPHERE_INDEX_TOO_BIG;
    return ETHER;
  }

  // Get Object index in entity array
  for(e_j=0; e_j<gEntities->entities_nb; e_j++) {
    if (!strcmp(monitoringSphereInput->objectName.name, gEntities->entities[e_j]->robotPt->name)){
      break;
    }
  }
  if( e_j == gEntities->entities_nb) {
    *report = S_spark_OBJECT_NOT_FOUND;
    return ETHER;
  }


  // Get Agent index in agent array
  for(a_i=0; a_i<gAgents->all_agents_no; a_i++){
    if (!strcmp(monitoringSphereInput->agentName.name, gAgents->all_agents[a_i]->robotPt->name)){            break;
    }
  }

  if(a_i == gAgents->all_agents_no){
    *report = S_spark_AGENT_NOT_FOUND;
    return ETHER;
  }

  if(monitoringSphereInput->handIndexInput >= gAgents->all_agents[a_i]->hand_nb){
    *report = S_spark_AGENT_HAND_INDEX_TOO_BIG;
    return ETHER;
  }

  hriUpdateSphereInSpheres(gAgents, gEntities, gSpheres ,SPARK_NUM_SPHERES_MAX, monitoringSphereInput->monitorIndex, monitoringSphereInput->activateSphere, monitoringSphereInput->agentName.name, a_i, monitoringSphereInput->objectName.name,e_j, monitoringSphereInput->sphereCenter.x,monitoringSphereInput->sphereCenter.y,monitoringSphereInput->sphereCenter.z , monitoringSphereInput->sphereRadius, monitoringSphereInput->sphereRadiusMultiply, monitoringSphereInput->sphereCenterTranslationMultiply , monitoringSphereInput->filteringTimeThreshold, (HRI_SPHERE_TYPE) monitoringSphereInput->sphereType);
  return ETHER;
}


/* ------------------------------------------------------------- */
/* ---------  Visualisation Poster  ------------------- */
/* ------------------------------------------------------------- */

void publishVisuInfoPoster( void )
{
  sparkVisuInfovisualizationsInfoPosterWrite(SPARK_VISUINFO_POSTER_ID, &SDI_F->visualizationsInfo);
}



int UpdateSomeVisuInfo(  GEN_BOOL addVisuInfo , SPARK_VISU_INFO visuInfo ){
  int numVisuInfo = SDI_F->visualizationsInfo.numVisusInfo;
  bool startShiftingVisuInPoster = false;

  if(addVisuInfo == GEN_TRUE){
    //check if these ids is already used
    int newIndex = numVisuInfo;
    for(int i=0; i<SDI_F->visualizationsInfo.numVisusInfo; i++) {
      if( (SDI_F->visualizationsInfo.visusInfos[i].createrId == visuInfo.createrId) &&
          (SDI_F->visualizationsInfo.visusInfos[i].createrVisuId == visuInfo.createrVisuId)){
        newIndex = i;
        break;
      }
    }

    //try add a visu info.
    if( (visuInfo.type > -1) && (visuInfo.type < SPARK_VISU_INFO_TYPE_ENUM_MAX)){
      if((numVisuInfo < SPARK_VISU_NUM_MAX)||(newIndex != numVisuInfo)){
        SDI_F->visualizationsInfo.visusInfos[newIndex].isVisuActive = 1;
        copyVec(visuInfo.point1,SDI_F->visualizationsInfo.visusInfos[newIndex].point1);
        copyVec(visuInfo.point2,SDI_F->visualizationsInfo.visusInfos[newIndex].point2);
        SDI_F->visualizationsInfo.visusInfos[newIndex].r = visuInfo.r;
        SDI_F->visualizationsInfo.visusInfos[newIndex].g = visuInfo.g;
        SDI_F->visualizationsInfo.visusInfos[newIndex].b = visuInfo.b;
        SDI_F->visualizationsInfo.visusInfos[newIndex].opacity = visuInfo.opacity;
        SDI_F->visualizationsInfo.visusInfos[newIndex].radius = visuInfo.radius;
        SDI_F->visualizationsInfo.visusInfos[newIndex].length1 = visuInfo.length1;
        SDI_F->visualizationsInfo.visusInfos[newIndex].length2 = visuInfo.length2;
        SDI_F->visualizationsInfo.visusInfos[newIndex].createrId = visuInfo.createrId;
        SDI_F->visualizationsInfo.visusInfos[newIndex].createrVisuId = visuInfo.createrVisuId;
        SDI_F->visualizationsInfo.visusInfos[newIndex].type = visuInfo.type;
        if(newIndex == numVisuInfo)
          SDI_F->visualizationsInfo.numVisusInfo++;
      }
      else{
        return S_spark_TOO_MANY_VISU_INFO;
      }
    }
    else{
      return S_spark_UNKNOWN_VISU_TYPE;
    }
  }
  else{
    //find tje visu info to be deleted
    for(int i=0; i<SDI_F->visualizationsInfo.numVisusInfo; i++) {
      if(startShiftingVisuInPoster){
        SDI_F->visualizationsInfo.visusInfos[i-1].isVisuActive = SDI_F->visualizationsInfo.visusInfos[i].isVisuActive;
        copyVec(SDI_F->visualizationsInfo.visusInfos[i].point1,SDI_F->visualizationsInfo.visusInfos[i-1].point1);
        copyVec(SDI_F->visualizationsInfo.visusInfos[i].point2,SDI_F->visualizationsInfo.visusInfos[i-1].point2);
        SDI_F->visualizationsInfo.visusInfos[i-1].r = SDI_F->visualizationsInfo.visusInfos[i].r;
        SDI_F->visualizationsInfo.visusInfos[i-1].g = SDI_F->visualizationsInfo.visusInfos[i].g;
        SDI_F->visualizationsInfo.visusInfos[i-1].b = SDI_F->visualizationsInfo.visusInfos[i].b;
        SDI_F->visualizationsInfo.visusInfos[i-1].opacity = SDI_F->visualizationsInfo.visusInfos[i].opacity;
        SDI_F->visualizationsInfo.visusInfos[i-1].radius = SDI_F->visualizationsInfo.visusInfos[i].radius;
        SDI_F->visualizationsInfo.visusInfos[i-1].length1 = SDI_F->visualizationsInfo.visusInfos[i].length1;
        SDI_F->visualizationsInfo.visusInfos[i-1].length2 = SDI_F->visualizationsInfo.visusInfos[i].length2;
        SDI_F->visualizationsInfo.visusInfos[i-1].createrId = SDI_F->visualizationsInfo.visusInfos[i].createrId;
        SDI_F->visualizationsInfo.visusInfos[i-1].createrVisuId = SDI_F->visualizationsInfo.visusInfos[i].createrVisuId;
        SDI_F->visualizationsInfo.visusInfos[i-1].type = SDI_F->visualizationsInfo.visusInfos[i].type;
      }
      if((SDI_F->visualizationsInfo.visusInfos[i].createrId == visuInfo.createrId) && (SDI_F->visualizationsInfo.visusInfos[i].createrVisuId == visuInfo.createrVisuId)){
        startShiftingVisuInPoster = true;
      }
    }
    if(startShiftingVisuInPoster){
      SDI_F->visualizationsInfo.numVisusInfo--;
      SDI_F->visualizationsInfo.visusInfos[SDI_F->visualizationsInfo.numVisusInfo].isVisuActive = 0;
    }
    else{
      return S_spark_VISU_INFO_NOT_ALREADY_HERE;
    }
  }
  return -5;
}

int getCreaterVisuIdFromAgentVisuReachabilityIndex( int agentIndex , int insideAgentIndex){
  return SPARK_VISU_REACHABILITY_BY_AGENT_MAX*agentIndex+insideAgentIndex;
}

int getCreaterVisuIdFromAgentVisuDivergentBeliefIndex( int agentIndex , int insideAgentIndex){
  return SPARK_VISU_REACHABILITY_BY_AGENT_MAX*SPARK_VISU_AGENT_MAX + SPARK_VISU_DIVERGENT_BELIEF_BY_AGENT_MAX*agentIndex+insideAgentIndex;
}

void getAgentVisuReachabilityIndexFromCreaterVisuId( int visuIndex , int &agentIndex , int &insideAgentIndex){
  agentIndex = visuIndex/SPARK_VISU_REACHABILITY_BY_AGENT_MAX;
  insideAgentIndex = visuIndex - SPARK_VISU_REACHABILITY_BY_AGENT_MAX*agentIndex;
}

// Check that visualization spheres for reachability are well positioned

void CheckVisuInfoForReachabilityPosition( void){
  if(SDI_F->visuInfoManagement.showReachability){

    int maxReachabilityIndex = SPARK_VISU_REACHABILITY_BY_AGENT_MAX*SPARK_VISU_AGENT_MAX;
    SPARK_3D_COORD entityReachabilityVisuForAgentPosition;
    int agentIndex;
    int insideAgentIndex;

    int numUpdate = 0;
    int entityIndex = -1;


    for(int i=0; i<SDI_F->visualizationsInfo.numVisusInfo; i++) {
      //is it a reachability visu index : createrId == 0 and createrVisuId < SPARK_VISU_REACHABILITY_BY_AGENT_MAX*SPARK_VISU_AGENT_MAX
      if( (SDI_F->visualizationsInfo.visusInfos[i].createrId == 0) &&
          (SDI_F->visualizationsInfo.visusInfos[i].createrVisuId < maxReachabilityIndex)){

        getAgentVisuReachabilityIndexFromCreaterVisuId( SDI_F->visualizationsInfo.visusInfos[i].createrVisuId , agentIndex , insideAgentIndex);
        entityIndex = SDI_F->visuInfoManagement.showReachabilityEntityVisuMapping[agentIndex][insideAgentIndex];
        // printf("checking entity position for index : %d createrVisuId %d agent id %d , insideAgent id %d entity %d\n",i,SDI_F->visualizationsInfo.visusInfos[i].createrVisuId,agentIndex,insideAgentIndex,entityIndex);
        if(entityIndex > -1){
          ///get points where visu should be for this entity and agent
          //compare it to the value that is in the poster.
          createVec(gEntities->entities[entityIndex]->robotPt->joints[1]->abs_pos[0][3]+SDI_F->visuInfoManagement.horizontalOffSet[agentIndex].x,gEntities->entities[entityIndex]->robotPt->joints[1]->abs_pos[1][3]+SDI_F->visuInfoManagement.horizontalOffSet[agentIndex].y,gEntities->entities[entityIndex]->robotPt->joints[1]->abs_pos[2][3]+SDI_F->visuInfoManagement.verticalOffSet.z,entityReachabilityVisuForAgentPosition);
          if(getDistanceBetweenPoints(entityReachabilityVisuForAgentPosition,SDI_F->visualizationsInfo.visusInfos[i].point1) > SDI_F->visuInfoManagement.distMaxBeforeUpdate){
            copyVec(entityReachabilityVisuForAgentPosition,SDI_F->visualizationsInfo.visusInfos[i].point1);
            //Also update radius and opacity in case it has changed.
            SDI_F->visualizationsInfo.visusInfos[i].radius = SDI_F->visuInfoManagement.radius;
            SDI_F->visualizationsInfo.visusInfos[i].opacity = SDI_F->visuInfoManagement.opacity;
            numUpdate++;
          }
        }
      }
    }
    if(numUpdate > 0)
      publishVisuInfoPoster();
  }
}

// add one visu sphere for object reachabilities

int UpdateSomeVisuInfoForReachability( int agentIndex,int entityIndex , bool isReachable ){
  if(SDI_F->visuInfoManagement.showReachability){

    if(agentIndex < SPARK_VISU_AGENT_MAX){
      int isFreeIndex = -1;
      int existingIndex = -1;
      GEN_BOOL addVisuInfo;
      SPARK_VISU_INFO visuInfo;
      bool updateVisuInfo = false;


      for(int i = 0; i < SPARK_VISU_REACHABILITY_BY_AGENT_MAX ; i++){
        if(SDI_F->visuInfoManagement.showReachabilityEntityVisuMapping[agentIndex][i] == entityIndex)
          existingIndex = i;
        if(SDI_F->visuInfoManagement.showReachabilityEntityVisuMapping[agentIndex][i] == -1)
          isFreeIndex = i;
      }

      // add visualisation if
      if(isReachable){
        if(existingIndex == -1){
          if(isFreeIndex > -1){
            visuInfo.createrVisuId = getCreaterVisuIdFromAgentVisuReachabilityIndex(agentIndex,isFreeIndex);
            SDI_F->visuInfoManagement.showReachabilityEntityVisuMapping[agentIndex][isFreeIndex] = entityIndex;
          }
          else
            printf("no free index to add reachability visu for agent %d entity %d\n",agentIndex,entityIndex);
        }
  else{
      visuInfo.createrVisuId =  getCreaterVisuIdFromAgentVisuReachabilityIndex(agentIndex,existingIndex);
      SDI_F->visuInfoManagement.showReachabilityEntityVisuMapping[agentIndex][existingIndex] = entityIndex;
  }
  addVisuInfo = GEN_TRUE;
  updateVisuInfo = true;
  visuInfo.isVisuActive = 1;    
      }
      else{
        if(existingIndex > -1){
          addVisuInfo = GEN_FALSE;
          updateVisuInfo = true;
          visuInfo.isVisuActive = 0;
          visuInfo.createrVisuId = getCreaterVisuIdFromAgentVisuReachabilityIndex(agentIndex,existingIndex);
          SDI_F->visuInfoManagement.showReachabilityEntityVisuMapping[agentIndex][existingIndex] = -1;
        }
      }

      if(updateVisuInfo){
        visuInfo.point1.x = gEntities->entities[entityIndex]->robotPt->joints[1]->abs_pos[0][3]+SDI_F->visuInfoManagement.horizontalOffSet[agentIndex].x;
        visuInfo.point1.y = gEntities->entities[entityIndex]->robotPt->joints[1]->abs_pos[1][3]+SDI_F->visuInfoManagement.horizontalOffSet[agentIndex].y;
        visuInfo.point1.z = gEntities->entities[entityIndex]->robotPt->joints[1]->abs_pos[2][3]+SDI_F->visuInfoManagement.verticalOffSet.z;

        visuInfo.r = SDI_F->visuInfoManagement.r[agentIndex];
        visuInfo.g = SDI_F->visuInfoManagement.g[agentIndex];
        visuInfo.b = SDI_F->visuInfoManagement.b[agentIndex];
        visuInfo.opacity = 1.0;
        visuInfo.radius = 0.04;
        visuInfo.createrId = 0;
        visuInfo.type = SPARK_VISU_INFO_SPHERE;
        UpdateSomeVisuInfo( addVisuInfo , visuInfo);
        printf("updating reachability value %d visu for agent %d entity %d visu index is %d\n",isReachable,agentIndex,entityIndex,visuInfo.createrVisuId);
        return 1;	  
      }
    }
    else
      printf(" agent index %d bigger than max allowed %d\n",agentIndex,SPARK_VISU_AGENT_MAX);
  }
  return 0;
}

// add one visu sphere for divergent belief
// could/should be harmonized with previous function for reachability visu.

int UpdateSomeVisuInfoForDivergentBelief( int agentIndex,int entityIndex , bool hasDistinctLocation , bool hasKnownLocation ){
  if(SDI_F->visuInfoManagement.showDivergentBelief){
    
    if(agentIndex < SPARK_VISU_AGENT_MAX){
      int isFreeIndex = -1;
      int existingIndex = -1;
      GEN_BOOL addVisuInfo;
      SPARK_VISU_INFO visuInfo;
      bool updateVisuInfo = false;


      for(int i = 0; i < SPARK_VISU_DIVERGENT_BELIEF_BY_AGENT_MAX ; i++){
        if(SDI_F->visuInfoManagement.showDivergentBeliefEntityVisuMapping[agentIndex][i] == entityIndex)
        existingIndex = i;
        if(SDI_F->visuInfoManagement.showDivergentBeliefEntityVisuMapping[agentIndex][i] == -1)
        isFreeIndex = i;
      }
    
      // add visualisation if 
      if(hasDistinctLocation || !hasKnownLocation){
        if(existingIndex == -1){
          if(isFreeIndex > -1){
            visuInfo.createrVisuId = getCreaterVisuIdFromAgentVisuDivergentBeliefIndex(agentIndex,isFreeIndex);
            SDI_F->visuInfoManagement.showDivergentBeliefEntityVisuMapping[agentIndex][isFreeIndex] = entityIndex;
          }
          else
            printf("no free index to add divergeent visu for agent %d entity %d\n",agentIndex,entityIndex);
        }
        else{
          visuInfo.createrVisuId = getCreaterVisuIdFromAgentVisuDivergentBeliefIndex(agentIndex,existingIndex);
          SDI_F->visuInfoManagement.showDivergentBeliefEntityVisuMapping[agentIndex][existingIndex] = entityIndex;
        }
        addVisuInfo = GEN_TRUE;
        updateVisuInfo = true;
        visuInfo.isVisuActive = 1;   	
      }
      else{
        if(existingIndex > -1){
          addVisuInfo = GEN_FALSE;
          updateVisuInfo = true;
          visuInfo.isVisuActive = 0;
          visuInfo.createrVisuId = getCreaterVisuIdFromAgentVisuDivergentBeliefIndex(agentIndex,existingIndex);
          SDI_F->visuInfoManagement.showDivergentBeliefEntityVisuMapping[agentIndex][existingIndex] = -1;
        }      
      }

      if(updateVisuInfo){	
        if(hasDistinctLocation){
          visuInfo.point1.x = gAgents->all_agents[agentIndex]->knowledge->entities[entityIndex].entityPositionForAgent[6];
          visuInfo.point1.y = gAgents->all_agents[agentIndex]->knowledge->entities[entityIndex].entityPositionForAgent[7];
          visuInfo.point1.z = gAgents->all_agents[agentIndex]->knowledge->entities[entityIndex].entityPositionForAgent[8];
        }
        else{
          visuInfo.point1.x = gAgents->all_agents[agentIndex]->knowledge->entities[entityIndex].lastEntPosX;
          visuInfo.point1.y = gAgents->all_agents[agentIndex]->knowledge->entities[entityIndex].lastEntPosY;
          visuInfo.point1.z = gAgents->all_agents[agentIndex]->knowledge->entities[entityIndex].lastEntPosZ;
        }

        visuInfo.r = SDI_F->visuInfoManagement.r[agentIndex];
        visuInfo.g = SDI_F->visuInfoManagement.g[agentIndex];
        visuInfo.b = SDI_F->visuInfoManagement.b[agentIndex];
        if(hasDistinctLocation) 
          visuInfo.opacity = 1.0;
        else
          visuInfo.opacity = 0.45;
        visuInfo.radius = 0.1;
        visuInfo.createrId = 0;      
        visuInfo.type = SPARK_VISU_INFO_SPHERE;
        UpdateSomeVisuInfo( addVisuInfo , visuInfo);
        printf("updating divergent belief distinctLocation %d hasKnownLocation %d visu for agent %d entity %d visu index is %d\n",hasDistinctLocation,hasKnownLocation,agentIndex,entityIndex,visuInfo.createrVisuId);
        return 1;	  
      }
    }
    else
      printf(" agent index %d bigger than max allowed %d\n",agentIndex,SPARK_VISU_AGENT_MAX);
  }
  return 0;
}


ACTIVITY_EVENT
sparkUpdateVisuInfoInPosterMain(SPARK_VISU_INFO_INPUT* visuInfoInput, int *report)
{
  // printf("size of poster num  %d\n",sizeof(SDI_F->visualizationsInfo.numVisusInfo));
  // printf("size of poster 1st element  %d\n",sizeof(SDI_F->visualizationsInfo.visusInfos[0]));
  // printf("size of poster %d\n",sizeof(SDI_F->visualizationsInfo));

  /////////////////////////////
  // Need to change params
  /////////////////////////////
  SPARK_VISU_INFO_PARAM_CHANGE_TYPE type = visuInfoInput->autoVisuInSparkManagementParamChangeType;
  double doubleParam = visuInfoInput->autoVisuInSparkManagementDoubleParam;
  if(type == SPARK_VISU_INFO_PARAM_NO_PARAM_CHANGE){
    int res = UpdateSomeVisuInfo( visuInfoInput->addVisuInfo ,visuInfoInput->visuInfo );
    //printf(" UpdateSomeVisuInfo res =  %d\n", res);
    if(res > -4)
      *report = res;
    publishVisuInfoPoster();
  }
  else{
    if (type == SPARK_VISU_INFO_PARAM_REACH_RADIUS){
      SDI_F->visuInfoManagement.radius = doubleParam;
      printf(" Change radius to =  %f\n", doubleParam);
    }
    else if (type == SPARK_VISU_INFO_PARAM_REACH_ZOFFSET){
      SDI_F->visuInfoManagement.verticalOffSet.z = doubleParam;
      printf(" Change z offset to =  %f\n", doubleParam);
    }
    else if (type == SPARK_VISU_INFO_PARAM_REACH_DIST_BETWEEN_AGENTS_SPHERES){
      SDI_F->visuInfoManagement.distBetweenSphereCenters = doubleParam;
      //update horizontal offset
      for(int i = 0; i < SPARK_VISU_AGENT_MAX ; i++){
        SDI_F->visuInfoManagement.horizontalOffSet[i].x = -(SPARK_VISU_AGENT_MAX-1)*SDI_F->visuInfoManagement.distBetweenSphereCenters/2 +i*SDI_F->visuInfoManagement.distBetweenSphereCenters;
      }
      printf(" Change dist between sphere centers to =  %f\n", doubleParam);
    }
    else if (type == SPARK_VISU_INFO_PARAM_REACH_MAX_DIST_BEFORE_UPDATE){
        SDI_F->visuInfoManagement.distMaxBeforeUpdate = doubleParam;
        printf(" Change max dist sphere center move before update to =  %f\n", doubleParam);
   }
    else if (type == SPARK_VISU_INFO_PARAM_SWITCH_SHOW_REACHABILITY){
      if(SDI_F->visuInfoManagement.showReachability)
        SDI_F->visuInfoManagement.showReachability = GEN_FALSE;
      else
        SDI_F->visuInfoManagement.showReachability = GEN_TRUE;
    }
    else if (type == SPARK_VISU_INFO_PARAM_SWITCH_SHOW_DIVERGENT_BELIEFS){
      if(SDI_F->visuInfoManagement.showDivergentBelief)
        SDI_F->visuInfoManagement.showDivergentBelief = GEN_FALSE;
      else
        SDI_F->visuInfoManagement.showDivergentBelief = GEN_TRUE;
    }
    else if (type == SPARK_VISU_INFO_PARAM_SWITCH_SHOW_TABLE_POINTS){
      if(SDI_F->visuInfoManagement.showTablePoints)
        SDI_F->visuInfoManagement.showTablePoints = GEN_FALSE;
      else
        SDI_F->visuInfoManagement.showTablePoints = GEN_TRUE;
    }

  }



  return ETHER;
}


void fillVisuInfoPoster( void )
{
  SDI_F->visualizationsInfo.visusInfos[0].isVisuActive = 1;
  SDI_F->visualizationsInfo.visusInfos[0].point1.x = 6.0;
  SDI_F->visualizationsInfo.visusInfos[0].point1.y = 6.0;
  SDI_F->visualizationsInfo.visusInfos[0].point1.z = 1.0;
  SDI_F->visualizationsInfo.visusInfos[0].opacity = 1.0;
  SDI_F->visualizationsInfo.visusInfos[0].radius = 1.0;
  SDI_F->visualizationsInfo.visusInfos[0].type = SPARK_VISU_INFO_SPHERE;
  SDI_F->visualizationsInfo.visusInfos[0].createrId = 0;
}


#if defined(USE_MIGHTABILITY_MAPS)


/* Mightability Analyses Codels */
ACTIVITY_EVENT
sparkInit_MightabilityStart(STRUCT_AROUND_OBJ_INFO_FOR_MM *MM_around_obj,int *report)
{

  return EXEC;
}

ACTIVITY_EVENT
sparkInit_MightabilityMain(STRUCT_AROUND_OBJ_INFO_FOR_MM *MM_around_obj,int *report)
{

  Create_and_init_Mightability_Maps(MM_around_obj->around_obj_name);

  SDI_F->state.mightabilitiesEnabled=1;
  printf(">>>>> After Create_and_init_Mightability_Maps(), SDI_F->state.mightabilitiesEnabled=%d\n",SDI_F->state.mightabilitiesEnabled);
  return END;
}

ACTIVITY_EVENT
sparkInit_MightabilityInter(STRUCT_AROUND_OBJ_INFO_FOR_MM *MM_around_obj,int *report)
{

  return END;
}

ACTIVITY_EVENT
sparkInit_MightabilityEnd(STRUCT_AROUND_OBJ_INFO_FOR_MM *MM_around_obj,int *report)
{

  return ETHER;
}

//To Update Mightabilities
ACTIVITY_EVENT
sparkUpdate_MightabilityStart(int *report)
{
  if(SDI_F->MA_FLAGS.MIGHTABILITY_INITIALISED==1)
    {
      SDI_F->MA_FLAGS.PAUSE_MIGHTABILITY_UPDATE=0;//Set to false
      return EXEC;
    }
  else
    {
      printf(" Mightability Analysis is NOT Initialized so Mightability will not be updated\n");
      return END;
    }
}

ACTIVITY_EVENT
sparkUpdate_MightabilityMain(int *report)
{
  if(SDI_F->MA_FLAGS.PAUSE_MIGHTABILITY_UPDATE==0)
    {

      execute_Mightability_Map_functions();
      return EXEC;
    }

  if(SDI_F->MA_FLAGS.STOP_MIGHTABILITY_UPDATE==1)
    {
      return END;
    }

  return EXEC;
}

ACTIVITY_EVENT
sparkUpdate_MightabilityInter(int *report)
{

  return END;
}

ACTIVITY_EVENT
sparkUpdate_MightabilityEnd(int *report)
{
  printf(" Existing from Update_Mightability loop, you need to call this request again to restart the loop \n");
  return ETHER;
}

//To SET the flags related to Update Mightabilities
ACTIVITY_EVENT
sparkSet_Mightability_flagsStart(STRUCT_MIGHTABILITY_FLAGS *MA_FLAGS, int *report)
{
  return EXEC;
}

ACTIVITY_EVENT
sparkSet_Mightability_flagsMain(STRUCT_MIGHTABILITY_FLAGS *MA_FLAGS, int *report)
{
  printf(" Mightability Flags are set : SDI_F->MA_FLAGS.MIGHTABILITY_INITIALISED=%d,  SDI_F->MA_FLAGS.SATRT_MIGHTABILITY_UPDATE=%d, SDI_F->MA_FLAGS.STOP_MIGHTABILITY_UPDATE=%d, SDI_F->MA_FLAGS.PAUSE_MIGHTABILITY_UPDATE=%d\n", SDI_F->MA_FLAGS.MIGHTABILITY_INITIALISED, SDI_F->MA_FLAGS.SATRT_MIGHTABILITY_UPDATE, SDI_F->MA_FLAGS.STOP_MIGHTABILITY_UPDATE, SDI_F->MA_FLAGS.PAUSE_MIGHTABILITY_UPDATE);
  return END;
}

ACTIVITY_EVENT
sparkSet_Mightability_flagsInter(STRUCT_MIGHTABILITY_FLAGS *MA_FLAGS, int *report)
{

  return END;
}

ACTIVITY_EVENT
sparkSet_Mightability_flagsEnd(STRUCT_MIGHTABILITY_FLAGS *MA_FLAGS, int *report)
{

  return ETHER;
}

//// Agent State Analysis Codels

//Init Agen State Analysis
ACTIVITY_EVENT
sparkInitAgentStateAnalysisStart(int *report)
{

  return EXEC;
}

ACTIVITY_EVENT
sparkInitAgentStateAnalysisMain(int *report)
{
  init_agents_for_MA_and_ASA();

  char threshold_file_path[150];
  char *home_dir=getenv("HOME");
  printf(" Home directory is %s\n",home_dir);
  strcpy(threshold_file_path,home_dir);
  char threshold_file_name[50]="/Human_State_Analysis_Thresholds.txt";
  strcat(threshold_file_path,threshold_file_name);

  //"/home/akpandey/Human_State_Analysis_Thresholds.txt";
  prepare_for_Agent_State_Analysis(threshold_file_path);
  return END;
}

ACTIVITY_EVENT
sparkInitAgentStateAnalysisInter(int *report)
{

  return END;
}

ACTIVITY_EVENT
sparkInitAgentStateAnalysisEnd(int *report)
{

  return ETHER;
}

//Reload Threshold for Agent State Analysis
ACTIVITY_EVENT
sparkReloadThresholdForASAStart(int *report)
{

  return EXEC;
}

ACTIVITY_EVENT
sparkReloadThresholdForASAMain(int *report)
{

  char threshold_file_path[150];
  char *home_dir=getenv("HOME");
  printf(" Home directory is %s\n",home_dir);
  strcpy(threshold_file_path,home_dir);
  char threshold_file_name[50]="/Human_State_Analysis_Thresholds.txt";
  strcat(threshold_file_path,threshold_file_name);

  //"/home/akpandey/Human_State_Analysis_Thresholds.txt";
  init_thresholds_for_ASA(threshold_file_path);
  return END;
}

ACTIVITY_EVENT
sparkReloadThresholdForASAInter(int *report)
{

  return END;
}

ACTIVITY_EVENT
sparkReloadThresholdForASAEnd(int *report)
{

  return ETHER;
}


//StartAgentStateAnalysis
ACTIVITY_EVENT
sparkStartAgentStateAnalysisStart(int *report)
{

  return EXEC;
}

ACTIVITY_EVENT
sparkStartAgentStateAnalysisMain(int *report)
{

  if(STOP_AGENT_STATE_ANALYSIS==1)
    {
      printf(" STOP Agent State Analysis\n");
      STOP_AGENT_STATE_ANALYSIS=0;
      return END;
    }
  if ( (NewDataForASA==1) || (NewDataForASA==4)) {
    hri_execute_Agent_State_Analysis_functions();
    if (NewDataForASA==4)
      NewDataForASA=3;
  }
  return EXEC;
}

ACTIVITY_EVENT
sparkStartAgentStateAnalysisInter(int *report)
{

  return END;
}

ACTIVITY_EVENT
sparkStartAgentStateAnalysisEnd(int *report)
{

  return ETHER;
}

//StopAgentStateAnalysis

ACTIVITY_EVENT
sparkStopAgentStateAnalysisStart(int *report)
{
  STOP_AGENT_STATE_ANALYSIS=1;
  return EXEC;
}

ACTIVITY_EVENT
sparkStopAgentStateAnalysisMain(int *report)
{

  return END;
}

ACTIVITY_EVENT
sparkStopAgentStateAnalysisInter(int *report)
{

  return END;
}

ACTIVITY_EVENT
sparkStopAgentStateAnalysisEnd(int *report)
{

  return ETHER;
}

void printAgentsActivityFacts(int for_agent)
{

  printf(" ========= Status for agent %s =======\n",gEnv->robot[Ag_Activity_Fact[HUMAN1_MA].agent_index]->name);

  printf(" Whole Body : %d \n",Ag_Activity_Fact[for_agent].whole_body);
  printf(" Torso: %d \n",Ag_Activity_Fact[for_agent].torso);
  printf(" Head: %d \n",Ag_Activity_Fact[for_agent].head);

  printf(" Right Hand: %d \n",Ag_Activity_Fact[for_agent].right_hand);
  printf(" Right Hand: %d \n",Ag_Activity_Fact[for_agent].right_hand_mode);
  printf(" Left Hnad: %d \n",Ag_Activity_Fact[for_agent].left_hand);
  printf(" Left Hnad: %d \n",Ag_Activity_Fact[for_agent].left_hand_mode);
}


ACTIVITY_EVENT
sparkPrintAgentStateAnalysisStart(int *report)
{

  return EXEC;
}

ACTIVITY_EVENT
sparkPrintAgentStateAnalysisMain(int *report)
{
  if(PRINT_AGENT_STATE_FACTS==1)
    {
      PRINT_AGENT_STATE_FACTS=0;
    }
  else
    {
      PRINT_AGENT_STATE_FACTS=1;
    }

  ////printAgentsActivityFacts(HUMAN1_MA);
  return END;
}

ACTIVITY_EVENT
sparkPrintAgentStateAnalysisInter(int *report)
{

  return END;
}

ACTIVITY_EVENT
sparkPrintAgentStateAnalysisEnd(int *report)
{

  return ETHER;
}


//// To get the human facts by name
void get_human_facts_in(Agent_Activity_fact_by_names &Hum_facts_by_name, STRUCT_AGENT_ACTIVITY_FACTS *hum_activity_fact)
{
  strcpy(hum_activity_fact->agent_name,Hum_facts_by_name.agent_name);
  strcpy(hum_activity_fact->agent_motion,Hum_facts_by_name.agent_motion);
  strcpy(hum_activity_fact->body_turn,Hum_facts_by_name.body_turn);
  strcpy(hum_activity_fact->torso_turn,Hum_facts_by_name.torso_turn);
  strcpy(hum_activity_fact->head_turn,Hum_facts_by_name.head_turn);
  strcpy(hum_activity_fact->right_hand_status,Hum_facts_by_name.right_hand_status);
  strcpy(hum_activity_fact->right_hand_config_mode,Hum_facts_by_name.right_hand_config_mode);
  strcpy(hum_activity_fact->right_hand_occup_mode,Hum_facts_by_name.right_hand_occup_mode);
  strcpy(hum_activity_fact->right_hand_rest_mode_type,Hum_facts_by_name.right_hand_rest_mode_type);
  strcpy(hum_activity_fact->right_hand_on_support,Hum_facts_by_name.right_hand_on_support);
  strcpy(hum_activity_fact->right_hand_holding_object,Hum_facts_by_name.right_hand_holding_object);
  strcpy(hum_activity_fact->left_hand_status,Hum_facts_by_name.left_hand_status);
  strcpy(hum_activity_fact->left_hand_config_mode,Hum_facts_by_name.left_hand_config_mode);
  strcpy(hum_activity_fact->left_hand_occup_mode,Hum_facts_by_name.left_hand_occup_mode);
  strcpy(hum_activity_fact->left_hand_rest_mode_type,Hum_facts_by_name.left_hand_rest_mode_type);
  strcpy(hum_activity_fact->left_hand_on_support,Hum_facts_by_name.left_hand_on_support);
  strcpy(hum_activity_fact->left_hand_holding_object,Hum_facts_by_name.left_hand_holding_object);

}

ACTIVITY_EVENT
sparkGetHumanFactsByNameStart(STRUCT_AGENTS_ACTIVITY_FACTS *hum_activity_fact, int *report)
{

  return EXEC;
}

ACTIVITY_EVENT
sparkGetHumanFactsByNameMain(STRUCT_AGENTS_ACTIVITY_FACTS *hum_activity_fact,int *report)
{

  get_human_facts_in(Hum_facts_by_name[HUMAN1_MA],&hum_activity_fact->Agent_Facts[HUMAN1_MA]);

#ifdef HUMAN2_EXISTS_FOR_MA
  get_human_facts_in(Hum_facts_by_name[HUMAN2_MA],&hum_activity_fact->Agent_Facts[HUMAN2_MA]);
#endif
  return END;
}

ACTIVITY_EVENT
sparkGetHumanFactsByNameInter(STRUCT_AGENTS_ACTIVITY_FACTS *hum_activity_fact,int *report)
{

  return END;
}

ACTIVITY_EVENT
sparkGetHumanFactsByNameEnd(STRUCT_AGENTS_ACTIVITY_FACTS *hum_activity_fact,int *report)
{

  return ETHER;
}

//Codels related to show object facts

//StartShowObjectFacts
ACTIVITY_EVENT
sparkStartShowObjectFactsStart(STRUCT_SHOW_OBJECT_FACTS_FLAGS *show_obj_fact_flag, int *report)
{
  return EXEC;
}

ACTIVITY_EVENT
sparkStartShowObjectFactsMain(STRUCT_SHOW_OBJECT_FACTS_FLAGS *show_obj_fact_flag, int *report)
{
  printf(" Inside sparkStartShowObjectFactsMain with flag: SDI_F->show_obj_fact_flag.show_arrow=%d  \n", SDI_F->show_obj_fact_flag.show_arrow);
  SHOW_OBJ_FACTS_BY_ARROW=SDI_F->show_obj_fact_flag.show_arrow;
  SHOW_OBJECT_FACTS=1;
  return END;
}

ACTIVITY_EVENT
sparkStartShowObjectFactsInter(STRUCT_SHOW_OBJECT_FACTS_FLAGS *show_obj_fact_flag, int *report)
{

  return END;
}

ACTIVITY_EVENT
sparkStartShowObjectFactsEnd(STRUCT_SHOW_OBJECT_FACTS_FLAGS *show_obj_fact_flag, int *report)
{

  return ETHER;
}

//ResetShowObjectFactsData
ACTIVITY_EVENT
sparkResetShowObjectFactsDataStart(int *report)
{

  return EXEC;
}

ACTIVITY_EVENT
sparkResetShowObjectFactsDataMain(int *report)
{
  init_object_facts_data();
  printf(" ... Done   init_object_facts_data()\n");
  return END;
}

ACTIVITY_EVENT
sparkResetShowObjectFactsDataInter(int *report)
{

  return END;
}

ACTIVITY_EVENT
sparkResetShowObjectFactsDataEnd(int *report)
{

  return ETHER;
}

//StopShowObjectFacts
ACTIVITY_EVENT
sparkStopShowObjectFactsStart(int *report)
{

  return EXEC;
}

ACTIVITY_EVENT
sparkStopShowObjectFactsMain(int *report)
{
  SHOW_OBJECT_FACTS=0;
  return END;
}

ACTIVITY_EVENT
sparkStopShowObjectFactsInter(int *report)
{
  return END;
}

ACTIVITY_EVENT
sparkStopShowObjectFactsEnd(int *report)
{
  return ETHER;
}

#endif
