
/*****************************************************************************
*
* Emrah Akin Sisbot
* Aug 10
*
* File    : sparkConst.h
* Brief   :
*
******************************************************************************/

#ifndef SPARK_CONST_H
#define SPARK_CONST_H

#define SPARK_MAX_THINGS_NB 38
#define SPARK_MAX_AGENT_NB 7 // number maxi of humans + robots in the environmemt
#define SPARK_MAX_FREEFLYER_NB 30
// ----------------------

// OBJECT CONSTANTS

#define SPARK_OBJECT_DEFAULT_UPDATE_DIST 0.02 // Distance threshold (in meters) for motion detection
#define SPARK_OBJECT_DEFAULT_ROUGH_UPDATE_DIST 0.30 // Distance threshold (in meters) for motion detection (in monocular vision)

// --------------------

// HUMAN CONSTANTS

#define SPARK_HUMAN_HISTORY_LENGTH 5

#define SPARK_HUMAN_DEFAULT_HEAD_HAND_DIST 1.2

#define SPARK_HUMAN_DEFAULT_UPDATE_DIST 0.05
#define SPARK_HUMAN_DEFAULT_UPDATE_ANGLE 0.1
#define SPARK_HUMAN_DEFAULT_HAND_UPDATE_DIST 0.03
#define SPARK_HUMAN_DEFAULT_UPDATE_BIG_JUMP_DIST 0.4
#define SPARK_HUMAN_DEFAULT_UPDATE_BIG_JUMP_ANGLE M_PI_2

#define SPARK_HUMAN_DEFAULT_SITTING_HEAD_HEIGHT 1.4

#define SPARK_NIUT_TOTAL_IDS 16

// --------------------

// SITUATION ASSESSMENT CONSTANTS

#define SPARK_NB_MAX_FACTS 200

#define SPARK_FACT_OPERATION_MAX 800

#ifdef PR2
// SPARK loop on PR2 is much faster. We need a stronger filtering.
#define SPARK_OBJECT_HISTORY_LENGTH 40 // Number of iteration before considering an object to be static
#else
#define SPARK_OBJECT_HISTORY_LENGTH 4 // Number of iteration before considering an object to be static
#endif

#define SPARK_DEFAULT_VISIBILITY_RATIO 50
#define SPARK_FAR_LIMIT 2

// --------------------

// OBJECT POSITION UPDATE MANAGEMENT CONSTANTS
#define SPARK_OBJECT_POSITION_UPDATE_MANAGEMENT_STATE_OBJ_MAX 10

// MONITORING SPHERES CONSTANT
#define SPARK_NUM_SPHERES_MAX 10

//Spark visu poster
// 20 first visu slots are prioritary for in spark reachability visu
// 20 folowing are are prioritary to in spark divergent belief visu
#define SPARK_VISU_AGENT_MAX 4
#define SPARK_VISU_REACHABILITY_BY_AGENT_MAX 10
#define SPARK_VISU_DIVERGENT_BELIEF_BY_AGENT_MAX 10
#define SPARK_VISU_NUM_MAX 100

//Spark Pose Perception Info Poster
#define SPARK_POSE_PERCEPTION_MAX 200

//Spark Pan Tilt Info Poster
#define SPARK_PAN_TILT_MAX 100


//Info on request time
#define SPARK_REQUEST_TIME_MAX 10
// --------------------

// COMPATIBILITY WITH OTHER MODULES

#define SPARK_MOCAP_FRAME_TRANSLATION_X 4.6
#define SPARK_MOCAP_FRAME_TRANSLATION_Y -3

#define M3D_MAX_DOF 65

// --------------------

#define SPARK_JIDO_ROBOT_NAME "JIDOKUKA_ROBOT"
#define SPARK_HRP2_ROBOT_NAME "HRP2_ROBOT"
#define SPARK_PR2_ROBOT_NAME "PR2_ROBOT"


// DISTANCE MANAGEMENT CONSTANT
#define SPARK_DISTANCES_INFO_NUM_AGENTS_MAX 10
#define SPARK_DISTANCES_INFO_NUM_TABLES_MAX 10
#define SPARK_DISTANCES_INFO_NUM_OBJECTS_MAX 10
#define SPARK_DISTANCES_INFO_NUM_TABLE_POINTS_MAX 80
#define SPARK_DISTANCES_INFO_NUM_TRAJECTORIES_MAX 10
#define SPARK_DISTANCES_INFO_NUM_STEP_IN_TRAJECTORY_MAX 100

#endif
